#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Shortest city tour (solution)
# 
# Find the shortest path through a set of streets, solution of the first example.

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')
import matplotlib.pyplot as plt
plt.style.use("ggplot")


# In[2]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Problem definition

# In[3]:


from ensae_projects.datainc.data_geo_streets import get_seattle_streets, shapely_records
from ensae_projects.datainc.data_geo_streets import seattle_streets_set_small, folium_html_street_map

name = get_seattle_streets()
shapes, records, fields = shapely_records(name)
edges_index, edges, vertices, distances = seattle_streets_set_small(shapes, records)
folium_html_street_map(edges_index, shapes, html_width="80%", zoom_start=15)


# We display a simplified map.

# In[4]:


from ensae_projects.datainc.data_geo_streets import plot_streets_network
plot_streets_network(edges_index, edges, vertices, shapes, figsize=(10,10));


# ## Eulerian path
# 
# A solution is a set of indices of edges. Let's try `edges_index` without one edge as a solution.

# In[5]:


from ensae_projects.challenge.city_tour import best_euler_path
couples, solution, distance = best_euler_path(edges_index=edges_index, edges=edges,
                                              distances=distances, vertices=vertices, fLOG=print)
"distance", distance


# In[6]:


from ensae_projects.challenge.city_tour import euler_path
plot_streets_network(edges_index, edges, vertices, shapes, order=solution, figsize=(10,10));


# In[7]: